## bart 0.6.00

=== Makefile ===
# Copyright 2013-2015. The Regents of the University of California.
# Copyright 2015-2019. Martin Uecker <martin.uecker@med.uni-goettingen.de>
# All rights reserved. Use of this source code is governed by
# a BSD-style license which can be found in the LICENSE file.

# we have a two stage Makefile
MAKESTAGE ?= 1

# silent make
#MAKEFLAGS += --silent

# auto clean on makefile updates
AUTOCLEAN?=1

# clear out all implicit rules and variables
MAKEFLAGS += -R

# use for parallel make
AR=./ar_lock.sh

MKL?=0
CUDA?=0
ACML?=0
OMP?=1
SLINK?=0
DEBUG?=0
FFTWTHREADS?=1
ISMRMRD?=0
NOEXEC_STACK?=0

LOG_BACKEND?=0
LOG_SIEMENS_BACKEND?=0
LOG_ORCHESTRA_BACKEND?=0
LOG_GADGETRON_BACKEND?=0
ENABLE_MEM_CFL?=0
MEMONLY_CFL?=0


DESTDIR ?= /
PREFIX ?= usr/local/

BUILDTYPE = Linux
UNAME = $(shell uname -s)
NNAME = $(shell uname -n)

MYLINK=ln

ifeq ($(UNAME),Darwin)
	BUILDTYPE = MacOSX
	MYLINK = ln -s
endif

ifeq ($(BUILDTYPE), MacOSX)
	MACPORTS ?= 1
endif


ifeq ($(BUILDTYPE), Linux)
	# as the defaults changed on most Linux distributions
	# explicitly specify non-deterministic archives to not break make
	ARFLAGS ?= rsU
else
	ARFLAGS ?= rs
endif

ifeq ($(BUILDTYPE), Linux)
ifneq (,$(findstring Red Hat,$(shell gcc --version)))
	CPPFLAGS+=-I/usr/include/lapacke/
	LDFLAGS+=-L/usr/lib64/atlas -ltatlas
endif
endif

ifeq ($(UNAME),Cygwin)
	BUILDTYPE = Cygwin
	NOLAPACKE ?= 1
endif

ifeq ($(UNAME),CYGWIN_NT-10.0)
	BUILDTYPE = Cygwin
	NOLAPACKE ?= 1
endif




# Paths

here  = $(realpath $(dir $(lastword $(MAKEFILE_LIST))))
root := $(here)

srcdir = $(root)/src
libdir = $(root)/lib
bindir = $(root)/bin

export TOOLBOX_PATH=$(root)


# Automatic dependency generation

DEPFILE = $(*D)/.$(*F).d
DEPFLAG = -MMD -MF $(DEPFILE)
ALLDEPS = $(shell find $(srcdir) utests -name ".*.d")


# Compilation flags

OPT = -O3 -ffast-math
CPPFLAGS ?= -Wall -Wextra
CFLAGS ?= $(OPT) -Wmissing-prototypes
CXXFLAGS ?= $(OPT)

ifeq ($(BUILDTYPE), MacOSX)
	CC ?= gcc-mp-6
else
	CC ?= gcc
	# for symbols in backtraces
	LDFLAGS += -rdynamic
endif




# openblas

ifneq ($(BUILDTYPE), MacOSX)
BLAS_BASE ?= /usr/
else
ifeq ($(MACPORTS),1)
BLAS_BASE ?= /opt/local/
CPPFLAGS += -DUSE_MACPORTS
endif
BLAS_BASE ?= /usr/local/opt/openblas/
endif

# cuda

CUDA_BASE ?= /usr/local/


# acml

ACML_BASE ?= /usr/local/acml/acml4.4.0/gfortran64_mp/

# mkl
MKL_BASE ?= /opt/intel/mkl/lib/intel64/ 

# fftw

ifneq ($(BUILDTYPE), MacOSX)
FFTW_BASE ?= /usr/
else
FFTW_BASE ?= /opt/local/
endif


# Matlab

MATLAB_BASE ?= /usr/local/matlab/

# ISMRM

ISMRM_BASE ?= /usr/local/ismrmrd/



# Main build targets
#
TBASE=show slice crop resize join transpose squeeze flatten zeros ones flip circshift extract repmat bitmask reshape version delta copy casorati vec poly index
TFLP=scale invert conj fmac saxpy sdot spow cpyphs creal carg normalize cdf97 pattern nrmse mip avg cabs zexp
TNUM=fft fftmod fftshift noise bench threshold conv rss filter mandelbrot wavelet window var std fftrot
TRECO=pics pocsense sqpics itsense nlinv moba nufft rof tgv sake wave lrmatrix estdims estshift estdelay wavepsf wshfl rtnlinv
TCALIB=ecalib ecaltwo caldir walsh cc ccapply calmat svd estvar whiten rmfreq ssa bin
TMRI=homodyne poisson twixread fakeksp looklocker upat
TSIM=phantom traj
TIO=toimg



MODULES = -lnum -lmisc -lnum -lmisc

MODULES_pics = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
MODULES_sqpics = -lsense -liter -llinops -lwavelet -llowrank -lnoncart
MODULES_pocsense = -lsense -liter -llinops -lwavelet
MODULES_nlinv = -lnoir -liter -lnlops -llinops -lnoncart
MODULES_rtnlinv = -lnoir -liter -lnlops -llinops -lnoncart
MODULES_moba = -lmoba -lnoir -liter -lnlops -llinops -lwavelet -lnoncart
MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
MODULES_itsense = -liter -llinops
MODULES_ecalib = -lcalib
MODULES_ecaltwo = -lcalib
MODULES_estdelay = -lcalib
MODULES_caldir = -lcalib
MODULES_walsh = -lcalib
MODULES_calmat = -lcalib
MODULES_cc = -lcalib
MODULES_ccapply = -lcalib
MODULES_estvar = -lcalib
MODULES_nufft = -lnoncart -liter -llinops
MODULES_rof = -liter -llinops
MODULES_tgv = -liter -llinops
MODULES_bench = -lwavelet -llinops
MODULES_phantom = -lsimu -lgeom
MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet -lnlops -lmoba -lgeom
MODULES_sake = -lsake
MODULES_traj = -lnoncart
MODULES_wave = -liter -lwavelet -llinops -llowrank
MODULES_threshold = -llowrank -liter -ldfwavelet -llinops -lwavelet
MODULES_fakeksp = -lsense -llinops
MODULES_lrmatrix = -llowrank -liter -llinops
MODULES_estdims = -lnoncart -llinops
MODULES_ismrmrd = -lismrm
MODULES_wavelet = -llinops -lwavelet
MODULES_wshfl = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
MODULES_ssa = -lcalib
MODULES_bin = -lcalib


MAKEFILES = $(wildcard $(root)/Makefiles/Makefile.*)
ALLMAKEFILES = $(root)/Makefile $(wildcard $(root)/Makefile.* $(root)/*.mk $(root)/rules/*.mk $(root)/Makefiles/Makefile.*)

-include Makefile.$(NNAME)
-include Makefile.local
-include $(MAKEFILES)


# clang

ifeq ($(findstring clang,$(CC)),clang)
	CFLAGS += -fblocks
	LDFLAGS += -lBlocksRuntime
endif


CXX ?= g++
LINKER ?= $(CC)



ifeq ($(ISMRMRD),1)
TMRI += ismrmrd
MODULES_bart += -lismrm
endif

ifeq ($(NOLAPACKE),1)
CPPFLAGS += -DNOLAPACKE
MODULES += -llapacke
endif



XTARGETS += $(TBASE) $(TFLP) $(TNUM) $(TIO) $(TRECO) $(TCALIB) $(TMRI) $(TSIM)
TARGETS = bart $(XTARGETS)



ifeq ($(DEBUG),1)
CPPFLAGS += -g
CFLAGS += -g
endif

ifeq ($(NOEXEC_STACK),1)
CPPFLAGS += -DNOEXEC_STACK
endif

ifeq ($(PARALLEL),1)
MAKEFLAGS += -j
endif


ifeq ($(MAKESTAGE),1)
.PHONY: doc/commands.txt $(TARGETS)
default all clean allclean distclean doc/commands.txt doxygen test utest utest_gpu gputest pythontest $(TARGETS):
	make MAKESTAGE=2 $(MAKECMDGOALS)

tests/test-%: force
	make MAKESTAGE=2 $(MAKECMDGOALS)

force: ;

else


CPPFLAGS += $(DEPFLAG) -iquote $(srcdir)/
CFLAGS += -std=gnu11
CXXFLAGS += -std=c++14




default: bart doc/commands.txt .gitignore


-include $(ALLDEPS)




# cuda

NVCC = $(CUDA_BASE)/bin/nvcc


ifeq ($(CUDA),1)
CUDA_H := -I$(CUDA_BASE)/include
CPPFLAGS += -DUSE_CUDA $(CUDA_H)
ifeq ($(BUILDTYPE), MacOSX)
CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -m64 -lstdc++
else
CUDA_L := -L$(CUDA_BASE)/lib64 -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib64
endif 
else
CUDA_H :=
CUDA_L :=  
endif

# sm_20 no longer supported in CUDA 9
GPUARCH_FLAGS ?= 
NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 $(GPUARCH_FLAGS) -I$(srcdir)/ -m64 -ccbin $(CC)
#NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -fopenmp -O3  -I$(srcdir)/


%.o: %.cu
	$(NVCC) $(NVCCFLAGS) -c $^ -o $@
	$(NVCC) $(NVCCFLAGS) -M $^ -o $(DEPFILE)


# OpenMP

ifeq ($(OMP),1)
CFLAGS += -fopenmp
CXXFLAGS += -fopenmp
else
CFLAGS += -Wno-unknown-pragmas
CXXFLAGS += -Wno-unknown-pragmas
endif



# BLAS/LAPACK

ifeq ($(ACML),1)
BLAS_H := -I$(ACML_BASE)/include
BLAS_L := -L$(ACML_BASE)/lib -lgfortran -lacml_mp -Wl,-rpath $(ACML_BASE)/lib
CPPFLAGS += -DUSE_ACML
else
BLAS_H := -I$(BLAS_BASE)/include
ifeq ($(BUILDTYPE), MacOSX)
BLAS_L := -L$(BLAS_BASE)/lib -lopenblas
else
ifeq ($(NOLAPACKE),1)
BLAS_L := -L$(BLAS_BASE)/lib -llapack -lblas
CPPFLAGS += -Isrc/lapacke
else
BLAS_L := -L$(BLAS_BASE)/lib -llapacke -lblas
endif
endif
endif

ifeq ($(MKL),1)
BLAS_H := -I$(MKL_BASE)/include
BLAS_L := -L$(MKL_BASE)/lib/intel64 -lmkl_intel_lp64 -lmkl_gnu_thread -lmkl_core
CPPFLAGS += -DUSE_MKL -DMKL_Complex8="complex float" -DMKL_Complex16="complex double"
CFLAGS += -DUSE_MKL -DMKL_Complex8="complex float" -DMKL_Complex16="complex double"
endif



CPPFLAGS += $(FFTW_H) $(BLAS_H)



# png
PNG_L := -lpng

ifeq ($(SLINK),1)
	PNG_L += -lz
endif

ifeq ($(LINKER),icc)
	PNG_L += -lz
endif



# fftw

FFTW_H := -I$(FFTW_BASE)/include/
FFTW_L := -L$(FFTW_BASE)/lib -lfftw3f

ifeq ($(FFTWTHREADS),1)
	FFTW_L += -lfftw3f_threads
	CPPFLAGS += -DFFTWTHREADS
endif

# Matlab

MATLAB_H := -I$(MATLAB_BASE)/extern/include
MATLAB_L := -Wl,-rpath $(MATLAB_BASE)/bin/glnxa64 -L$(MATLAB_BASE)/bin/glnxa64 -lmat -lmx -lm -lstdc++

# ISMRM

ifeq ($(ISMRMRD),1)
ISMRM_H := -I$(ISMRM_BASE)/include
ISMRM_L := -L$(ISMRM_BASE)/lib -lismrmrd
else
ISMRM_H :=
ISMRM_L :=
endif

# Enable in-memory CFL files

ifeq ($(ENABLE_MEM_CFL),1)
CPPFLAGS += -DUSE_MEM_CFL
miscextracxxsrcs += $(srcdir)/misc/mmiocc.cc
LDFLAGS += -lstdc++
endif

# Only allow in-memory CFL files (ie. disable support for all other files)

ifeq ($(MEMONLY_CFL),1)
CPPFLAGS += -DMEMONLY_CFL
miscextracxxsrcs += $(srcdir)/misc/mmiocc.cc
LDFLAGS += -lstdc++
endif

# Logging backends

ifeq ($(LOG_BACKEND),1)
CPPFLAGS += -DUSE_LOG_BACKEND
ifeq ($(LOG_SIEMENS_BACKEND),1)
miscextracxxsrcs += $(srcdir)/misc/UTrace.cc
endif
ifeq ($(LOG_ORCHESTRA_BACKEND),1)
miscextracxxsrcs += $(srcdir)/misc/Orchestra.cc
endif
endif


# change for static linking

ifeq ($(SLINK),1)
# work around fortran problems with static linking
LDFLAGS += -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -Wl,--allow-multiple-definition
LIBS += -lmvec
BLAS_L += -llapack -lblas -lgfortran -lquadmath
endif



# Modules

.LIBPATTERNS := lib%.a

vpath %.a lib

boxextrasrcs := $(XTARGETS:%=src/%.c)

define alib
$(1)srcs := $(wildcard $(srcdir)/$(1)/*.c)
$(1)cudasrcs := $(wildcard $(srcdir)/$(1)/*.cu)
$(1)objs := $$($(1)srcs:.c=.o)
$(1)objs += $$($(1)extrasrcs:.c=.o)
$(1)objs += $$($(1)extracxxsrcs:.cc=.o)

ifeq ($(CUDA),1)
$(1)objs += $$($(1)cudasrcs:.cu=.o)
endif

.INTERMEDIATE: $$($(1)objs)

lib/lib$(1).a: lib$(1).a($$($(1)objs))

endef

ALIBS = misc num grecon sense noir iter linops wavelet lowrank noncart calib simu sake dfwavelet nlops moba lapacke box geom
$(eval $(foreach t,$(ALIBS),$(eval $(call alib,$(t)))))


# additional rules for lib misc
$(eval $(shell $(root)/rules/update-version.sh))

$(srcdir)/misc/version.o: $(srcdir)/misc/version.inc


# additional rules for lib ismrm
lib/libismrm.a: CPPFLAGS += $(ISMRM_H)


# lib linop
UTARGETS += test_linop_matrix test_linop
MODULES_test_linop += -llinops
MODULES_test_linop_matrix += -llinops

# lib lowrank
UTARGETS += test_batchsvd
MODULES_test_batchsvd = -llowrank

# lib misc
UTARGETS += test_pattern test_types test_misc

# lib moba
UTARGETS += test_moba
MODULES_test_moba += -lmoba -lnlops -llinops

# lib nlop
UTARGETS += test_nlop
MODULES_test_nlop += -lnlops -llinops

# lib noncart
UTARGETS += test_nufft
MODULES_test_nufft += -lnoncart -llinops

# lib num
UTARGETS += test_multind test_flpmath test_splines test_linalg test_polynom test_window
UTARGETS += test_blas test_mdfft test_ops test_ops_p
UTARGETS_GPU += test_cudafft

# lib simu
UTARGETS += test_ode_bloch test_biot_savart
MODULES_test_ode_bloch += -lsimu
MODULES_test_biot_savart += -lsimu

# lib iter
UTARGETS += test_iter test_prox
MODULES_test_iter += -liter -lnlops -llinops
MODULES_test_prox += -liter -llinops







# sort BTARGETS after everything is included
BTARGETS:=$(sort $(BTARGETS))
XTARGETS:=$(sort $(XTARGETS))



.gitignore: .gitignore.main Makefile*
	@echo '# AUTOGENERATED. DO NOT EDIT. (are you looking for .gitignore.main ?)' > .gitignore
	cat .gitignore.main >> .gitignore
	@echo $(patsubst %, /%, $(TARGETS) $(UTARGETS) $(UTARGETS_GPU)) | tr ' ' '\n' >> .gitignore


doc/commands.txt: bart
	./rules/update_commands.sh ./bart doc/commands.txt $(XTARGETS)

doxygen: makedoc.sh doxyconfig bart
	 ./makedoc.sh


all: .gitignore $(TARGETS)





# special targets


$(XTARGETS): CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h


bart: CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h


mat2cfl: $(srcdir)/mat2cfl.c -lnum -lmisc
	$(CC) $(CFLAGS) $(MATLAB_H) -omat2cfl  $+ $(MATLAB_L) $(CUDA_L)





# implicit rules

%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

%.o: %.cc
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

ifeq ($(PARALLEL),1)
(%): %
	$(AR) $(ARFLAGS) $@ $%
else
(%): %
	$(AR) $(ARFLAGS) $@ $%
endif




.SECONDEXPANSION:
$(TARGETS): % : src/main.c $(srcdir)/%.o $$(MODULES_%) $(MODULES)

=== tests/CMakeLists.txt ===
# Copyright 2018. Damien Nguyen <damien.nguyen@alumni.epfl.ch>
# All rights reserved. Use of this source code is governed by
# a BSD-style license which can be found in the LICENSE file.
# \author Damien Nguyen <damien.nguyen@alumni.epfl.ch>


# ==============================================================================
# Generate a pair of randomly named directories

# string(RANDOM LENGTH 4 ALPHABET "0123456789" _random)
set(_random "cmake")
set(_tests_data_dir "${CMAKE_CURRENT_BINARY_DIR}/data_${_random}")
set(_tests_out_dir "${CMAKE_CURRENT_BINARY_DIR}/out_${_random}")

add_custom_command(
  OUTPUT ${_tests_data_dir} ${_tests_out_dir}
  COMMAND ${CMAKE_COMMAND} -E make_directory "${_tests_data_dir}"
  COMMAND ${CMAKE_COMMAND} -E make_directory "${_tests_out_dir}"
  )

# ==============================================================================
# Main helper variables

set(_test_groups)
set(_test_list_data)
set(_data_file_list)
set(_data_cmd_list)

# ==============================================================================
# This macro parses a XXX.mk file and extracts its tests and related commands
#
# Each call to this macro appends a new group to the _test_groups list
# For each group XXX, a variable _test_list_XXX is created to store the names
# of the tests present in that group.
# For each test TTT in group XXX, a variable TEST_XXX_TTT contains the list of
# commands to execute for that particular test
macro(parse_test_file filename)
  # First get name of the group and add it to the global list
  get_filename_component(_group ${filename} NAME_WE)
  list(APPEND _test_groups ${_group})
  set(_test_list_${_group})

  # Read the file
  file(READ ${filename} _test_file_lines)
  string(REPLACE "\\" ";;" _test_file_lines ${_test_file_lines})
  string(REPLACE "\n" ";;" _test_file_lines ${_test_file_lines})

  # The following algorithm is relying on the fact that we first encounter a line
  # with the test name (of the form tests/test-name:) and then a series of
  # tab-indented lines that start with $(TOOLDIR)/some-command + arguments

  set(_curr_test)
  foreach(_line ${_test_file_lines})
    string(STRIP ${_line} _is_empty)
    if(NOT ${_is_empty} STREQUAL "")
      # Look for $(TOOLDIR) to find out if a line is a command or not
      string(FIND ${_line} "$(TOOLDIR)" _is_cmd)

      # Try to grab the test name
      string(REGEX MATCH "^tests/([^:]+)" _test_name ${_line})

      if(NOT "${_test_name}" STREQUAL "")
	# Got the name -> remove tests/ from the beginning of the string
	string(SUBSTRING ${_test_name} 6 -1 _test_name)
	string(REPLACE "-" "_" _test_name ${_test_name})
	# Add this test to the list of test for this group
	list(APPEND _test_list_${_group} ${_test_name})
	set(_curr_test ${_test_name})
      elseif(_is_cmd GREATER -1 AND NOT _curr_test STREQUAL "")
	# First chars are TAB + $ -> command part of a test
	
	# Separate line by whitespace
	string(REPLACE " " ";" _comp ${_line})

	set(_cmd)
	foreach(_c ${_comp})
	  # Starts with "\t$(TOOLDIR)" => it's the name of the command
	  string(REGEX MATCH "^\t\\$\\(TOOLDIR\\)/([a-zA-z0-9]+)" _cmd_name ${_c})
	  # Contains $(TESTS_OUT) => path to an input file in data diretory
	  string(REGEX MATCH "\\$\\(TESTS_OUT\\)/(.*)" _path ${_c})

	  if(NOT ${_cmd_name} STREQUAL "")
	    string(REPLACE "$(TOOLDIR)/" " $<TARGET_FILE:bart> " _cmd_name ${_cmd_name})
	    set(_cmd "${_cmd} ${_cmd_name}")
	  elseif(NOT ${_path} STREQUAL "")
	    string(REPLACE "$(TESTS_OUT)/" "${_tests_data_dir}/" _path ${_path})
	    file(TO_NATIVE_PATH ${_path} _path)
	    set(_cmd "${_cmd} ${_path}")
	  else()
	    set(_cmd "${_cmd} ${_c}")
	  endif()
	endforeach()

	# If we were called with some extra arguments, apply an extra processing
	# step to the command before adding it to the list
	if(${ARGC} GREATER 1)
	  _parse_cmdline_custom(${_cmd} ${ARGN})
	endif()

	# Cleanup string and add it to the list of commands for the current test
	string(STRIP ${_cmd} _cmd)
	list(APPEND TEST_${_group}_${_curr_test} ${_cmd})
      endif()
    else()
      # Reset current test name if we encounter anything else
      set(_curr_test)
    endif()
  endforeach()
endmacro()

# ------------------------------------------------------------------------------
# This macro parses a XXX.mk file and extracts the commands that generate some
# test data
#
# Each call to this macro may append some name XXX to the list of data files
# (_test_list_data). If a new test data file is found, then the command needed
# to generate the file is saved in the _data_XXX_cmd variable and the path to
# the file in the _data_XXX_file variable.
# Also, if the generation of the current data file is dependent on another one,
# the variable _data_XXX_deps will contain the file that needs to be created
# first.
macro(parse_test_file_for_data filename)
  # First read the file
  file(READ ${filename} _test_file_lines)
  string(REPLACE "\\" ";" _test_file_lines ${_test_file_lines})
  string(REPLACE "\n" ";" _test_file_lines ${_test_file_lines})

  set(_data_name)
  set(_data_cmd)
  foreach(_line ${_test_file_lines})
    string(STRIP ${_line} _is_empty)
    string(LENGTH ${_line} _str_length)
    if(NOT ${_is_empty} STREQUAL "" AND _str_length GREATER 12)
      string(SUBSTRING "${_line}" 0 12 _name_header)
      string(SUBSTRING "${_line}" 0 2  _cmd_header)

      if(_name_header STREQUAL "$(TESTS_OUT)")
	# Found a name line -> extract the name and add it to the list of names
	string(REGEX MATCH "\\$\\(TESTS_OUT\\)/([^:]+)" _data_name ${_line})
	string(REPLACE "$(TESTS_OUT)/" "" _data_name ${_data_name})
	get_filename_component(_bname ${_data_name} NAME_WE)
	list(APPEND _test_list_data ${_bname})
	set(_data_cmd)
      elseif(_data_name AND NOT _data_cmd AND ${_cmd_header} STREQUAL "\t$")
	# Got a command line -> parse it and save the command
	string(REPLACE "$(TOOLDIR)/" "$<TARGET_FILE:bart> " _data_cmd ${_line})

	# If the line contains $(TESTS_OUT) we have a dependency
	string(REGEX MATCH "\\$\\(TESTS_OUT\\)/([^ \t]+)" _data_deps ${_data_cmd})

	if(NOT _data_deps STREQUAL "")
	  # Modify the command to have the correct path
	  string(REPLACE "$(TESTS_OUT)/" "${_tests_data_dir}/" _data_cmd ${_data_cmd})
	  # Cleanup the dependency name and save it
	  string(REPLACE "$(TESTS_OUT)/" "" _data_deps ${_data_deps})
	  set(_data_${_bname}_deps "${_tests_data_dir}/${_data_deps}")
	endif()
	# Cleanup command line and then save it
	string(REPLACE "$@" "${_data_name}" _data_cmd ${_data_cmd})
	string(STRIP ${_data_cmd} _data_${_bname}_cmd)
	# Propery set the name of the data file and save it
	file(TO_NATIVE_PATH "${_tests_data_dir}/${_data_name}" _data_file)
	set(_data_${_bname}_file ${_data_file})
      else()
	set(_data_name)
	set(_data_cmd)
	set(_bname)
      endif()
    endif()
  endforeach()
endmacro()

# ------------------------------------------------------------------------------
# This macro processes the list of test data files to be generated and creates
# custom commands to generate them.
#
# We simply iterate over the list of data files, grab the required information
# and then generate a file to create the CMake custom command
macro(add_commands_for_test_data_generation)
  foreach(_data_name ${_test_list_data})
    # Set relevant helper variables
    set(TEST_DATA_OUTPUT ${_data_${_data_name}_file})
    set(TEST_DATA_CMD ${_data_${_data_name}_cmd})
    set(TEST_DATA_DEPS ${_tests_data_dir};${_data_${_data_name}_deps})
    set(TEST_DATA_DIR ${_tests_data_dir})
    # Generate the file...
    configure_file(${PROJECT_SOURCE_DIR}/cmake/tests_data_generation.cmake.in
      ${CMAKE_CURRENT_BINARY_DIR}/tests_datagen_${_data_name}.cmake @ONLY)
    # ...and include it
    include(${CMAKE_CURRENT_BINARY_DIR}/tests_datagen_${_data_name}.cmake)
    file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/tests_datagen_${_data_name}.cmake)
    # While we're at it also keep a list of all the test data files
    list(APPEND _data_file_list ${_data_${_data_name}_file})
  endforeach()
endmacro()

# ------------------------------------------------------------------------------
# This macro processes the list of tests for a particular group and generates
# a CMake script file in order to execute them
macro(create_integration_test group)
  # First, create a custom target to execute all the test in the group
  set(_grp_test_tgt integration_${group})
  add_custom_target(${_grp_test_tgt}
    DEPENDS ${_data_file_list})

  # Then iterate over all the tests in the group
  foreach(_test ${_test_list_${group}})
    # Skip GPU-related test if we did not compile with CUDA support
    string(REGEX MATCH ".*gpu.*" _test_require_gpu ${_test})
    if(USE_CUDA OR _test_require_gpu STREQUAL "")
      # Build the CMake script file content
      set(_cmd_list "set(_error_flag 0)\n")
      list(APPEND _cmd_list "execute_process(COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --blue \"Executing ${_test}\")\n")
      foreach(_cmd ${TEST_${group}_${_test}})
	set(_exec_in)
	
	# Set environment variables before calling the command if required
	if(NOT ${_test_${group}_env_name} STREQUAL "")
	  foreach(_name ${_test_${group}_env_name})
            set(_exec_in "${_exec_in}\nset(ENV{${_name}} \"${_test_${group}_env_val}\")")
	  endforeach()
	endif()

	string(REPLACE "\"" "\\\"" _cmd_escaped ${_cmd})
	
	# For each command in the test, we make a call execute_process()
	set(_exec_in "${_exec_in}\nexecute_process(\nCOMMAND ${_cmd}\nRESULT_VARIABLE res_var\nWORKING_DIRECTORY ${_tests_out_dir}\nOUTPUT_VARIABLE _output\nERROR_VARIABLE _output)\nif(NOT \"\${res_var}\" STREQUAL \"0\")\n  message(ERROR \"Command ${_cmd_escaped} failed with return \${res_var}:\\n \${_output} \")\nset(_error_flag 1)\nendif()\n\n")
	list(APPEND _cmd_list "${_exec_in}")
      endforeach()
      list(APPEND _cmd_list "if(_error_flag)\nexecute_process(COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --red \"FAILED\")\nelse()\nexecute_process(COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --green \"PASSED\")\nendif()\n")
      string(REPLACE ";" "\n" _cmd_list ${_cmd_list})

      # Finally, we write the file...
      file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_test}.cmake CONTENT "${_cmd_list}")
      # ...and create a target to execute it.
      add_custom_command(TARGET ${_grp_test_tgt}
	POST_BUILD
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/${_test}.cmake)
    endif()
  endforeach()
endmacro()

# ==============================================================================
# Macro to handle some special cases
set(_python_cmd_match "python")
macro(_parse_cmdline_custom cmd type)
  if(${type} STREQUAL ${_python_cmd_match})
    string(REGEX MATCH "PYTHONPATH.*" _is_python ${cmd})
    if(NOT _is_python STREQUAL "")
      string(REGEX REPLACE "PYTHONPATH[^ \t]+(.*)" "${Python_EXECUTABLE}\\1" _cmd "${cmd}")
      string(REGEX REPLACE "\\$\\(TOOLDIR\\)/(.*)" "${PROJECT_SOURCE_DIR}/\\1" _cmd "${_cmd}")
    endif()
  endif()
endmacro()

# ==============================================================================
# Macros to manually add some tests (ie. not based on some *.mk file)
macro(add_new_test_group group)
  list(APPEND _test_groups ${group})
endmacro()

macro(add_test_to_group group test_name)
  list(APPEND _test_list_${group} ${test_name})
  set(TEST_${group}_${test_name} ${ARGN})
endmacro()

macro(add_env_var_to_group group name value)
  set(_test_${group}_env_name "${name}")
  set(_test_${group}_env_val "${value}")
endmacro()

# ==============================================================================

# Now that we have all our macros, we simply iterate over all the XXX.mk files
# in the folder, while skipping some incompatible tests
#   - join: calls commands like `seq 1 300` which may not work if not on Linux
#   - estdelay: one call to `$(TOOLDIR)/estdelay` in the middle of another
#               command -> impossible to do with the current approach
#
# NB: the GPU-only tests are already ignored when parsing the tests file

=== debian/changelog ===
bart (0.6.00-3) unstable; urgency=medium

  * Team upload
  * Remove redundant d/gbp.conf
  * Run tests on i386, mips64el and s390x but make the test succeed in any case

 -- Andreas Tille <tille@debian.org>  Mon, 21 Sep 2020 16:16:16 +0200

bart (0.6.00-2) unstable; urgency=medium

  * Team upload.
  * Mark tests superficial
    Closes: #969804
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 10 Sep 2020 08:59:31 +0200

bart (0.6.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Add upstream metadata.
  * Rules do not require root.
  * Standards-Version: 4.5.0

  [ Andreas Tille ]
  * Add salsa-ci

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Sat, 11 Jul 2020 15:42:45 +0200

=== debian/control ===
Source: bart
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libfftw3-dev,
               liblapack-dev | liblapack.so,
               libpng-dev,
               liblapacke-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/bart
Vcs-Git: https://salsa.debian.org/med-team/bart.git
Homepage: https://mrirecon.github.io/bart/
Rules-Requires-Root: no

Package: bart
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: octave-bart
Description: tools for computational magnetic resonance imaging
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging. It consists of a programming library and a toolbox
 of command-line programs. The library provides common operations on
 multi-dimensional arrays, Fourier and wavelet transforms, as well as
 generic implementations of iterative optimization algorithms. The
 command-line tools provide direct access to basic operations on
 multi-dimensional arrays as well as efficient implementations of
 many calibration and reconstruction algorithms for parallel imaging
 and compressed sensing.

Package: libbart-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: Development files for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides headers and static libraries.

Package: octave-bart
Architecture: all
Depends: bart,
         ${misc:Depends}
Recommends: octave
Description: Octave bindings for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides Octave bindings for BART.

=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart
Restrictions: superficial

Tests: octave-integration
Depends: octave-bart, octave
Restrictions: superficial

## bart 0.7.00

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,7 @@
 # use for parallel make
 AR=./ar_lock.sh
 
+# use for ppc64le HPC
 MKL?=0
 CUDA?=0
 ACML?=0
@@ -25,8 +26,11 @@
 SLINK?=0
 DEBUG?=0
 FFTWTHREADS?=1
+SCALAPACK?=0
 ISMRMRD?=0
 NOEXEC_STACK?=0
+PARALLEL?=0
+PARALLEL_NJOBS?=
 
 LOG_BACKEND?=0
 LOG_SIEMENS_BACKEND?=0
@@ -45,6 +49,7 @@
 
 MYLINK=ln
 
+
 ifeq ($(UNAME),Darwin)
 	BUILDTYPE = MacOSX
 	MYLINK = ln -s
@@ -134,7 +139,7 @@
 
 # cuda
 
-CUDA_BASE ?= /usr/local/
+CUDA_BASE ?= /usr/
 
 
 # acml
@@ -142,7 +147,7 @@
 ACML_BASE ?= /usr/local/acml/acml4.4.0/gfortran64_mp/
 
 # mkl
-MKL_BASE ?= /opt/intel/mkl/lib/intel64/ 
+MKL_BASE ?= /opt/intel/mkl/lib/intel64/
 
 # fftw
 
@@ -167,11 +172,11 @@
 #
 TBASE=show slice crop resize join transpose squeeze flatten zeros ones flip circshift extract repmat bitmask reshape version delta copy casorati vec poly index
 TFLP=scale invert conj fmac saxpy sdot spow cpyphs creal carg normalize cdf97 pattern nrmse mip avg cabs zexp
-TNUM=fft fftmod fftshift noise bench threshold conv rss filter mandelbrot wavelet window var std fftrot
-TRECO=pics pocsense sqpics itsense nlinv moba nufft rof tgv sake wave lrmatrix estdims estshift estdelay wavepsf wshfl rtnlinv
+TNUM=fft fftmod fftshift noise bench threshold conv rss filter mandelbrot wavelet window var std fftrot roistat pol2mask conway
+TRECO=pics pocsense sqpics itsense nlinv moba nufft rof tgv sake wave lrmatrix estdims estshift estdelay wavepsf wshfl rtnlinv mobafit
 TCALIB=ecalib ecaltwo caldir walsh cc ccapply calmat svd estvar whiten rmfreq ssa bin
 TMRI=homodyne poisson twixread fakeksp looklocker upat
-TSIM=phantom traj
+TSIM=phantom traj signal
 TIO=toimg
 
 
@@ -183,7 +188,8 @@
 MODULES_pocsense = -lsense -liter -llinops -lwavelet
 MODULES_nlinv = -lnoir -liter -lnlops -llinops -lnoncart
 MODULES_rtnlinv = -lnoir -liter -lnlops -llinops -lnoncart
-MODULES_moba = -lmoba -lnoir -liter -lnlops -llinops -lwavelet -lnoncart
+MODULES_moba = -lmoba -lnoir -lnlops -llinops -lwavelet -lnoncart -lsimu -lgrecon -llowrank -llinops -liter
+MODULES_mobafit = -lmoba -lnlops -llinops -lsimu -liter
 MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
 MODULES_itsense = -liter -llinops
 MODULES_ecalib = -lcalib
@@ -213,6 +219,8 @@
 MODULES_wshfl = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
 MODULES_ssa = -lcalib
 MODULES_bin = -lcalib
+MODULES_signal = -lsimu
+MODULES_pol2mask = -lgeom
 
 
 MAKEFILES = $(wildcard $(root)/Makefiles/Makefile.*)
@@ -262,18 +270,19 @@
 CPPFLAGS += -DNOEXEC_STACK
 endif
 
+
 ifeq ($(PARALLEL),1)
-MAKEFLAGS += -j
+MAKEFLAGS += -j$(PARALLEL_NJOBS)
 endif
 
 
 ifeq ($(MAKESTAGE),1)
 .PHONY: doc/commands.txt $(TARGETS)
 default all clean allclean distclean doc/commands.txt doxygen test utest utest_gpu gputest pythontest $(TARGETS):
-	make MAKESTAGE=2 $(MAKECMDGOALS)
+	$(MAKE) MAKESTAGE=2 $(MAKECMDGOALS)
 
 tests/test-%: force
-	make MAKESTAGE=2 $(MAKECMDGOALS)
+	$(MAKE) MAKESTAGE=2 $(MAKECMDGOALS)
 
 force: ;
 
@@ -306,15 +315,15 @@
 ifeq ($(BUILDTYPE), MacOSX)
 CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -m64 -lstdc++
 else
-CUDA_L := -L$(CUDA_BASE)/lib64 -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib64
-endif 
+CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib
+endif
 else
 CUDA_H :=
-CUDA_L :=  
+CUDA_L :=
 endif
 
 # sm_20 no longer supported in CUDA 9
-GPUARCH_FLAGS ?= 
+GPUARCH_FLAGS ?=
 NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 $(GPUARCH_FLAGS) -I$(srcdir)/ -m64 -ccbin $(CC)
 #NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -fopenmp -O3  -I$(srcdir)/
 
@@ -337,7 +346,9 @@
 
 
 # BLAS/LAPACK
-
+ifeq ($(SCALAPACK),1)
+BLAS_L :=  -lopenblas -lscalapack
+else
 ifeq ($(ACML),1)
 BLAS_H := -I$(ACML_BASE)/include
 BLAS_L := -L$(ACML_BASE)/lib -lgfortran -lacml_mp -Wl,-rpath $(ACML_BASE)/lib
@@ -352,6 +363,7 @@
 CPPFLAGS += -Isrc/lapacke
 else
 BLAS_L := -L$(BLAS_BASE)/lib -llapacke -lblas
+endif
 endif
 endif
 endif
@@ -439,10 +451,14 @@
 # change for static linking
 
 ifeq ($(SLINK),1)
+ifeq ($(SCALAPACK),1)
+BLAS_L += -lgfortran -lquadmath
+else
 # work around fortran problems with static linking
 LDFLAGS += -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -Wl,--allow-multiple-definition
 LIBS += -lmvec
 BLAS_L += -llapack -lblas -lgfortran -lquadmath
+endif
 endif
 
 
@@ -473,6 +489,9 @@
 endef
 
 ALIBS = misc num grecon sense noir iter linops wavelet lowrank noncart calib simu sake dfwavelet nlops moba lapacke box geom
+ifeq ($(ISMRMRD),1)
+ALIBS += ismrm
+endif
 $(eval $(foreach t,$(ALIBS),$(eval $(call alib,$(t)))))
 
 
@@ -500,7 +519,7 @@
 
 # lib moba
 UTARGETS += test_moba
-MODULES_test_moba += -lmoba -lnlops -llinops
+MODULES_test_moba += -lmoba -lnoir -llowrank -lwavelet -liter -lnlops -llinops -lsimu
 
 # lib nlop
 UTARGETS += test_nlop
@@ -511,14 +530,19 @@
 MODULES_test_nufft += -lnoncart -llinops
 
 # lib num
-UTARGETS += test_multind test_flpmath test_splines test_linalg test_polynom test_window
-UTARGETS += test_blas test_mdfft test_ops test_ops_p
+UTARGETS += test_multind test_flpmath test_splines test_linalg test_polynom test_window test_conv
+UTARGETS += test_blas test_mdfft test_ops test_ops_p test_flpmath2
 UTARGETS_GPU += test_cudafft
 
 # lib simu
-UTARGETS += test_ode_bloch test_biot_savart
+UTARGETS += test_ode_bloch test_biot_savart test_signals
 MODULES_test_ode_bloch += -lsimu
 MODULES_test_biot_savart += -lsimu
+MODULES_test_signals += -lsimu
+
+# lib geom
+UTARGETS += test_geom
+MODULES_test_geom += -lgeom
 
 # lib iter
 UTARGETS += test_iter test_prox
@@ -559,37 +583,3 @@
 # special targets
 
 
-$(XTARGETS): CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h
-
-
-bart: CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h
-
-
-mat2cfl: $(srcdir)/mat2cfl.c -lnum -lmisc
-	$(CC) $(CFLAGS) $(MATLAB_H) -omat2cfl  $+ $(MATLAB_L) $(CUDA_L)
-
-
-
-
-
-# implicit rules
-
-%.o: %.c
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
-
-%.o: %.cc
-	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<
-
-ifeq ($(PARALLEL),1)
-(%): %
-	$(AR) $(ARFLAGS) $@ $%
-else
-(%): %
-	$(AR) $(ARFLAGS) $@ $%
-endif
-
-
-
-
-.SECONDEXPANSION:
-$(TARGETS): % : src/main.c $(srcdir)/%.o $$(MODULES_%) $(MODULES)

=== debian/changelog ===
bart (0.7.00-2) unstable; urgency=medium

  * Fix cross-builds by reverting patch for deterministic archives.
  * Arm the unit tests on mips64el.
  * Add workaround for compiler bug on armel and s390x.
  * Drop old compatibility patch.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 30 Dec 2021 16:28:18 +0100

bart (0.7.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Patch to change library path for cuda.
  * Update upstream metadata.
  * Patch to relax failing unit test.
  * Patch to work around compiler bug.
  * Deterministic build.
  * Run test suite.
  * Don't update commands.txt.
  * Backport fixes for tests.

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)
  * No tab in license text (routine-update)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 26 Aug 2021 15:05:30 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# set installation prefix
export PREFIX=/usr/

# Some tests fail on the following architectures probably
# due to minor differences in floating point processing.
# For now, just turn it off...
NOTEST_ARCHS=armel armhf mips mipsel hurd-i386 kfreebsd-i386 m68k powerpcspe sh4

# For this architesture the test will be run but it will pass in any case even when errors occure
PRINT_ERRORS_WHEN_TESTING=i386 s390x

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(NOTEST_ARCHS), $(DEB_BUILD_ARCH)))
ifeq (,$(filter $(PRINT_ERRORS_WHEN_TESTING), $(DEB_BUILD_ARCH)))
	make utest
else
	# the test will be run but its passing in any case
	make utest || true
endif
endif
endif

=== debian/tests/control ===
--- 
+++ 
@@ -5,3 +5,17 @@
 Tests: octave-integration
 Depends: octave-bart, octave
 Restrictions: superficial
+
+Tests: commands
+Depends: bart
+Restrictions: superficial
+
+Tests: suite
+Depends: bart, make
+Architecture: amd64
+Restrictions: allow-stderr
+
+Tests: suite
+Depends: bart, make
+Architecture: i386, mips64el, s390x
+Restrictions: allow-stderr, flaky

## bart 0.8.00

=== debian/changelog ===
bart (0.8.00-3) unstable; urgency=medium

  * Run more unit tests.
  * Turn off two hanging tests on i386.
  * Add geometry library now required by bart-view.

 -- Martin Uecker <uecker@tugraz.at>  Tue, 25 Oct 2022 01:12:46 +0530

bart (0.8.00-2) unstable; urgency=medium

  * Backport fixes for upstream (should also fix 32-bit archs)
  * Turn on tests for more archs.
  * Turn off some optimizations for some archs.
  * Update debian copyright.
  * Relax some flaky tests.

 -- Martin Uecker <uecker@tugraz.at>  Thu, 13 Oct 2022 19:30:06 +0200

bart (0.8.00-1) unstable; urgency=medium

  * Turn off LTO build due to GCC bug #1017849. (Closes: #1015357)
  * Add std=c++14 to nvcc to fix build issues.
  * New upstream version.
  * Standards-Version: 4.6.1.0
  * Extend devel-package.
  * Mention machine learning in description.

 -- Martin Uecker <uecker@tugraz.at>  Sun, 25 Sep 2022 13:48:43 +0200

bart (0.7.00-3) unstable; urgency=medium

  * Turn off parallel build for determinism.
  * Arm the unit tests on s390x.
  * On Debian never use git version.
  * Workaround for octave bug in integration test. (Closes: #1010164)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Fri, 31 Dec 2021 10:31:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: bart
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
+Uploaders: Martin Uecker <uecker@tugraz.at>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -8,7 +8,7 @@
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/
@@ -28,8 +28,8 @@
  generic implementations of iterative optimization algorithms. The
  command-line tools provide direct access to basic operations on
  multi-dimensional arrays as well as efficient implementations of
- many calibration and reconstruction algorithms for parallel imaging
- and compressed sensing.
+ many calibration and reconstruction algorithms for parallel imaging,
+ compressed sensing, and machine learning.
 
 Package: libbart-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,19 +1,35 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 # set installation prefix
 export PREFIX=/usr/
 
+# turn of parallel builds here to make build deterministic
+export PARALLEL=1
+export PARALLEL_NJOBS=1
+
+# some archs require turning of some optimizations
+NOEXPOPT_ARCHS=arm64 ppc64el s390x ia64 powerpc ppc64 riscv64
+
+# turn off hanging tests on i386
+ifeq ($(DEB_BUILD_ARCH), i386)
+export ODE_SIMU_OFF=1
+endif
+
+ifneq (,$(filter $(NOEXPOPT_ARCHS), $(DEB_BUILD_ARCH)))
+export DEB_CFLAGS_MAINT_APPEND = -fno-expensive-optimizations
+endif
+
 # Some tests fail on the following architectures probably
 # due to minor differences in floating point processing.
 # For now, just turn it off...
-NOTEST_ARCHS=armel armhf mips mipsel hurd-i386 kfreebsd-i386 m68k powerpcspe sh4
+NOTEST_ARCHS=hurd-i386 kfreebsd-i386
 
 # For this architesture the test will be run but it will pass in any case even when errors occure
-PRINT_ERRORS_WHEN_TESTING=i386 s390x
+PRINT_ERRORS_WHEN_TESTING=alpha sh4 arc m68k
 
 %:
 	dh $@
